/* Map Finish Command Execution v1.1.1 Lua Script for SRB2 2.1.25
 Made by: ChaoLoveIceMDBoy (2019) */

local serverClusterData = {ID = "srb2-server-cluster", name = "SRB2 Server Cluster"}
local commandBufferBlockSize = 256
local serverCommandBufferSize = 32 + commandBufferBlockSize * 32
local clientCommandBufferSize = 1 + commandBufferBlockSize
local serverCommandBuffer = {}
local clientCommandBuffer = {}
local joiningPlayers = {}
local commandsForClientsPreparationStage = {}
for lengthOfCommandBuffers = 1,serverCommandBufferSize
	serverCommandBuffer[lengthOfCommandBuffers] = nil
end
for numOfPlayers = 1,32
	clientCommandBuffer[numOfPlayers] = {}
	for lengthOfCommandBuffers = 1,clientCommandBufferSize
		clientCommandBuffer[numOfPlayers][lengthOfCommandBuffers] = nil
	end
	joiningPlayers[numOfPlayers] = false
	commandsForClientsPreparationStage[numOfPlayers] = -1
end

addHook("NetVars", function(net)
	serverClusterData = net(serverClusterData)
	commandBufferBlockSize = net(commandBufferBlockSize)
	serverCommandBufferSize = net(serverCommandBufferSize)
	clientCommandBufferSize = net(clientCommandBufferSize)
	serverCommandBuffer = net(serverCommandBuffer)
	clientCommandBuffer = net(clientCommandBuffer)
	joiningPlayers = net(joiningPlayers)
	commandsForClientsPreparationStage = net(commandsForClientsPreparationStage)
end)

local function checkCommandBufferSize(buffer)
	if buffer == 0
		return clientCommandBufferSize
	elseif buffer == 1
		return serverCommandBufferSize
	end
end

local function setCommandInCommandBuffer(player, buffer, index, command)
	if not index or type(index) != "number" or index < 1 or index > checkCommandBufferSize(buffer) return end
	if not command or type(command) != "string" return end
	if command == "exitgame" or command == "quit" return end
	if buffer == 0
		if not player or not player.valid
			for numOfPlayers = 1,32
				clientCommandBuffer[numOfPlayers][index] = command
			end
		else
			clientCommandBuffer[#player+1][index] = command
		end
	elseif buffer == 1
		serverCommandBuffer[index] = command
	end
end

local function setCommandsInCommandBuffer(player, buffer, startindex, finishindex, command)
	if not startindex or type(startindex) != "number" or startindex < 1 or startindex > checkCommandBufferSize(buffer) return end
	if not finishindex or type(finishindex) != "number" or finishindex < 1 or finishindex > checkCommandBufferSize(buffer) return end
	if not command or type(command) != "string" return end
	if command == "exitgame" or command == "quit" return end
	if finishindex - startindex == 0
		return
	elseif finishindex - startindex > 0
		for numOfCommandsToSet = startindex,finishindex
			setCommandInCommandBuffer(player, buffer, numOfCommandsToSet, command)
		end
	elseif finishindex - startindex < 0
		for numOfCommandsToSet = startindex,finishindex,-1
			setCommandInCommandBuffer(player, buffer, numOfCommandsToSet, command)
		end
	end
end

local function unsetCommandInCommandBuffer(player, buffer, index)
	if not index or type(index) != "number" or index < 1 or index > checkCommandBufferSize(buffer) return end
	if buffer == 0
		if not player or not player.valid
			for numOfPlayers = 1,32
				clientCommandBuffer[numOfPlayers][index] = nil
			end
		else
			clientCommandBuffer[#player+1][index] = nil
		end
	elseif buffer == 1
		serverCommandBuffer[index] = nil
	end
end

local function unsetCommandsInCommandBuffer(player, buffer, startindex, finishindex)
	if not startindex or type(startindex) != "number" or startindex < 1 or startindex > checkCommandBufferSize(buffer) return end
	if not finishindex or type(finishindex) != "number" or finishindex < 1 or finishindex > checkCommandBufferSize(buffer) return end
	if finishindex - startindex == 0
		return
	elseif finishindex - startindex > 0
		for numOfCommandsToUnset = startindex,finishindex
			unsetCommandInCommandBuffer(player, buffer, numOfCommandsToUnset)
		end
	elseif finishindex - startindex < 0
		for numOfCommandsToUnset = startindex,finishindex,-1
			unsetCommandInCommandBuffer(player, buffer, numOfCommandsToUnset)
		end
	end
end

local function executeCommandFromCommandBuffer(player, buffer, index)
	if not player or not player.valid return end
	if not index or type(index) != "number" or index < 1 or index > checkCommandBufferSize(buffer) return end
	if buffer == 0
		if not clientCommandBuffer[#player+1][index] or type(clientCommandBuffer[#player+1][index]) != "string" return end
		COM_BufInsertText(player, clientCommandBuffer[#player+1][index])
	elseif buffer == 1
		if not serverCommandBuffer[index] or type(serverCommandBuffer[index]) != "string" return end
		COM_BufInsertText(player, serverCommandBuffer[index])
	end
	unsetCommandInCommandBuffer(player, buffer, index)
end

local function executeCommandsFromCommandBuffer(player, buffer, startindex, finishindex)
	if not player or not player.valid return end
	if not startindex or type(startindex) != "number" or startindex < 1 or startindex > checkCommandBufferSize(buffer) return end
	if not finishindex or type(finishindex) != "number" or finishindex < 1 or finishindex > checkCommandBufferSize(buffer) return end
	if finishindex - startindex == 0
		return
	elseif finishindex - startindex > 0
		for numOfCommandsToExecute = startindex,finishindex
			executeCommandFromCommandBuffer(player, buffer, numOfCommandsToExecute)
		end
	elseif finishindex - startindex < 0
		for numOfCommandsToExecute = startindex,finishindex,-1
			executeCommandFromCommandBuffer(player, buffer, numOfCommandsToExecute)
		end
	end
end

local function transferCommandBetweenCommandBuffers(player, srcbuffer, srcindex, destbuffer, destindex, copy)
	if not srcindex or type(srcindex) != "number" or srcindex < 1 or srcindex > checkCommandBufferSize(srcbuffer) return end
	if not destindex or type(destindex) != "number" or destindex < 1 or destindex > checkCommandBufferSize(destbuffer) return end
	if srcbuffer == destbuffer
		return
	elseif srcbuffer == 0 and destbuffer == 1
		if not clientCommandBuffer[#player+1][srcindex] or type(clientCommandBuffer[#player+1][srcindex]) != "string" return end
		setCommandInCommandBuffer(player, destbuffer, destindex, clientCommandBuffer[#player+1][srcindex])
	elseif srcbuffer == 1 and destbuffer == 0
		if not serverCommandBuffer[srcindex] or type(serverCommandBuffer[srcindex]) != "string" return end
		setCommandInCommandBuffer(player, destbuffer, destindex, serverCommandBuffer[srcindex])
	end
	if not copy
		unsetCommandInCommandBuffer(player, srcbuffer, srcindex)
	end
end

local function transferCommandsBetweenCommandBuffers(player, srcbuffer, srcstartindex, srcfinishindex, destbuffer, destindexoffset, copy)
	if not srcstartindex or type(srcstartindex) != "number" or srcstartindex < 1 or srcstartindex > checkCommandBufferSize(srcbuffer) return end
	if not srcfinishindex or type(srcfinishindex) != "number" or srcfinishindex < 1 or srcfinishindex > checkCommandBufferSize(srcbuffer) return end
	if srcstartindex+destindexoffset < 1 or srcstartindex+destindexoffset > checkCommandBufferSize(destbuffer) or srcfinishindex+destindexoffset < 1 or srcfinishindex+destindexoffset > checkCommandBufferSize(destbuffer) return end
	if srcfinishindex - srcstartindex == 0
		return
	elseif srcfinishindex - srcstartindex > 0
		for numOfCommandsToTransfer = srcstartindex,srcfinishindex
			transferCommandBetweenCommandBuffers(player, srcbuffer, numOfCommandsToTransfer, destbuffer, numOfCommandsToTransfer+destindexoffset, copy)
		end
	elseif srcfinishindex - srcstartindex < 0
		for numOfCommandsToTransfer = srcstartindex,srcfinishindex,-1
			transferCommandBetweenCommandBuffers(player, srcbuffer, numOfCommandsToTransfer, destbuffer, numOfCommandsToTransfer+destindexoffset, copy)
		end
	end
end

local function prepareCommandsForClients(player, ...)
	if not player or not player.valid return end
	if player != server and not IsPlayerAdmin(player) return end
	for player in players.iterate
		if not player or not player.valid continue end
		if commandsForClientsPreparationStage[#player+1] != 1 continue end
		if player.exiting > 0
			local numOfPreparedCommands = 0
			for k,v in pairs({...})
				if numOfPreparedCommands >= 256 break end
				if not v or type(v) != "string" continue end
				if v == "exitgame" or v == "quit" continue end
				setCommandInCommandBuffer(server, 1, (32+(#player+1)*commandBufferBlockSize)-commandBufferBlockSize+1+numOfPreparedCommands, v)
				numOfPreparedCommands = $+1
			end
			commandsForClientsPreparationStage[#player+1] = 0
		end
	end
end

local function setClusterData(player, clusterID, clusterName)
	if not player or not player.valid return end
	if player != server and not IsPlayerAdmin(player) return end
	if not serverClusterData or type(serverClusterData) != "table" return end
	if not clusterID or type(clusterID) != "string" return end
	if not clusterName or type(clusterName) != "string" return end
	serverClusterData.ID = clusterID
	serverClusterData.name = clusterName
end

local function showClusterData(player)
	if not player or not player.valid return end
	if not serverClusterData or type(serverClusterData) != "table" return end
	if not serverClusterData.ID or type(serverClusterData.ID) != "string" return end
	if not serverClusterData.name or type(serverClusterData.name) != "string" return end
	CONS_Printf(player, "You are currently playing on a server cluster called " + serverClusterData.name + " with an ID of " + serverClusterData.ID + "!\n")
end

addHook("MapChange", function(mapnum)
	unsetCommandsInCommandBuffer(nil, 1, 1, serverCommandBufferSize)
	unsetCommandsInCommandBuffer(nil, 0, 1, clientCommandBufferSize)
	for numOfPlayers = 1,32
		commandsForClientsPreparationStage[numOfPlayers] = -1
	end
	COM_BufInsertText(server, "exec MFCE\\mfce-setup.cfg")
end)

addHook("PlayerJoin", function(playernum)
	unsetCommandInCommandBuffer(player, 1, playernum+1)
	unsetCommandsInCommandBuffer(player, 1, (32+(playernum+1)*commandBufferBlockSize)-commandBufferBlockSize+1, 32+(playernum+1)*commandBufferBlockSize)
	unsetCommandsInCommandBuffer(nil, 0, 1, clientCommandBufferSize)
	joiningPlayers[playernum+1] = true
	commandsForClientsPreparationStage[playernum+1] = -1
end)

addHook("PlayerQuit", function(player, reason)
	unsetCommandInCommandBuffer(player, 1, #player+1)
	unsetCommandsInCommandBuffer(player, 1, (32+(#player+1)*commandBufferBlockSize)-commandBufferBlockSize+1, 32+(#player+1)*commandBufferBlockSize)
	unsetCommandsInCommandBuffer(player, 0, 1, clientCommandBufferSize)
	joiningPlayers[#player+1] = false
	commandsForClientsPreparationStage[#player+1] = -1
end)

addHook("PlayerSpawn", function(player)
	unsetCommandInCommandBuffer(player, 1, #player+1)
	unsetCommandsInCommandBuffer(player, 1, (32+(#player+1)*commandBufferBlockSize)-commandBufferBlockSize+1, 32+(#player+1)*commandBufferBlockSize)
	unsetCommandsInCommandBuffer(player, 0, 1, clientCommandBufferSize)
	joiningPlayers[#player+1] = false
	commandsForClientsPreparationStage[#player+1] = -1
end)

addHook("ThinkFrame", function()
	// TODO: Redo how the MFCE client and server configs work after the implementation of IO support.
	for player in players.iterate
		if not joiningPlayers[#player+1]
			if player.exiting > 0
				if commandsForClientsPreparationStage[#player+1] <= -1
					commandsForClientsPreparationStage[#player+1] = 1
				end
				transferCommandsBetweenCommandBuffers(player, 1, (32+(#player+1)*commandBufferBlockSize)-commandBufferBlockSize+1, 32+(#player+1)*commandBufferBlockSize, 0, -((32+(#player+1)*commandBufferBlockSize)-commandBufferBlockSize-1), 0)
				executeCommandsFromCommandBuffer(player, 0, 1, clientCommandBufferSize)
				if not player or not player.valid continue end
				executeCommandFromCommandBuffer(server, 1, #player+1)
			else
				setCommandInCommandBuffer(player, 0, 1, "exec MFCE\\mfce-client-Cluster" + serverClusterData.ID + "-" + G_BuildMapName(gamemap) + "-Tag" + tostring(player.mo.subsector.sector.tag) + ".cfg")
				setCommandInCommandBuffer(server, 1, #player+1, "exec MFCE\\mfce-server-Cluster" + serverClusterData.ID + "-" + G_BuildMapName(gamemap) + "-Tag" + tostring(player.mo.subsector.sector.tag) + ".cfg")
			end
		end
	end
end)

COM_AddCommand("prepareCommandsForClients", prepareCommandsForClients, true)
COM_AddCommand("setClusterData", setClusterData, true)
COM_AddCommand("showClusterData", showClusterData)